import { Base, Point, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-angular-core/ES2015/type";
import { ITrackThumbVisual } from "./ITrackThumbVisual";
import { ITrackRangeVisual } from "./ITrackRangeVisual";
import { ITrackBarVisual } from "./ITrackBarVisual";
import { ITrackShadeVisual } from "./ITrackShadeVisual";
import { ITrackThumbCalloutVisual } from "./ITrackThumbCalloutVisual";
import { FontInfo } from "igniteui-angular-core/ES2015/FontInfo";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { TextBlock } from "igniteui-angular-core/ES2015/TextBlock";
import { DoubleAnimator } from "igniteui-angular-core/ES2015/DoubleAnimator";
import { Size } from "igniteui-angular-core/ES2015/Size";
import { ITrackOwner } from "./ITrackOwner";
import { IZoomSlider } from "igniteui-angular-core/ES2015/IZoomSlider";
import { TrackThumb } from "./TrackThumb";
import { TrackThumbRange } from "./TrackThumbRange";
import { ZoomSliderVisualArea } from "./ZoomSliderVisualArea";
import { ZoomSliderOrientation } from "./ZoomSliderOrientation";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { ZoomSliderResolvingAxisValueEventArgs } from "./ZoomSliderResolvingAxisValueEventArgs";
import { RectChangedEventArgs } from "igniteui-angular-core/ES2015/RectChangedEventArgs";
export declare class ZoomSliderView extends Base {
    static $t: Type;
    constructor(a: ZoomSlider);
    private p;
    i: ITrackThumbVisual;
    h: ITrackThumbVisual;
    c: ITrackRangeVisual;
    b: ITrackBarVisual;
    e: ITrackShadeVisual;
    d: ITrackShadeVisual;
    g: ITrackThumbCalloutVisual;
    f: ITrackThumbCalloutVisual;
    j: ZoomSlider;
    an(): void;
    ai(): void;
    private az();
    private at();
    private av(a);
    private au(a);
    private ay(a, b, c);
    private ax(a, b, c);
    private u;
    private v;
    private o;
    private s;
    private q;
    private x;
    private w;
    private m;
    private a;
    am(): void;
    private t;
    ar(a: any): void;
    private af(a, b);
    private ag(a, b);
    private ah(a, b);
    private aa();
    as(): void;
    ao(): void;
    private ap(a);
    aj(): void;
    n(): FontInfo;
    private l;
    private y;
    private r;
    a0(a: TextBlock, b: string, c: FontInfo): void;
    private k;
    ac(): void;
    ae(): void;
    ab(): void;
    ad(): void;
    a1(a: TextBlock): Size;
    aq(): void;
    aw(): void;
    al(): void;
    private ak();
}
export declare class ZoomSlider extends Base implements ITrackOwner, INotifyPropertyChanged, IZoomSlider {
    static $t: Type;
    protected b: TrackThumb;
    protected a: TrackThumb;
    protected c: TrackThumbRange;
    protected g: ZoomSliderView;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private bk;
    bl: number;
    private ax;
    bg: number;
    private az;
    bi: number;
    private ag;
    a4: number;
    resolvingAxisValue: (sender: any, args: ZoomSliderResolvingAxisValueEventArgs) => void;
    de(a: number, b: number, c: number, d: number): void;
    d6(): void;
    private fg;
    private w;
    windowRect: Rect;
    private d7();
    private af;
    private dg(a, b);
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private i;
    private h;
    private ff;
    private fe;
    c8(a: Point): void;
    private c1();
    private c0();
    da(a: Point, b: number): void;
    ae(a: Point): boolean;
    private ad(a, b);
    private di(a);
    private dm(a, b);
    private ac(a);
    private x(a);
    c9(a: Point): void;
    private c2();
    private dd(a);
    private dw(a);
    private dk(a, b, c);
    private d1(a);
    private fk;
    private fl();
    private dl(a, b, c);
    private n();
    private c4(a);
    c6(a: Point): void;
    c7(a: Point): void;
    j(a: Point): ZoomSliderVisualArea;
    private r(a);
    private u(a, b, c);
    private t(a, b);
    private s(a, b);
    private v(a, b, c);
    fj: Rect;
    fh: Rect;
    fi: Rect;
    private d3(a, b);
    private du(a);
    private dz(a);
    private dp(a);
    private d5(a, b);
    private ds(a, b);
    private dr(a, b);
    private bm();
    private bn();
    private ay;
    bh: number;
    private a1;
    startInset: number;
    private al;
    endInset: number;
    private a3;
    trackStartInset: number;
    private a2;
    trackEndInset: number;
    private ah;
    barExtent: number;
    private d;
    e: ZoomSliderOrientation;
    private en;
    e8: Brush;
    private av;
    be: number;
    private ap;
    a9: number;
    private ef;
    e0: Brush;
    private eo;
    e9: Brush;
    private eg;
    e1: Brush;
    private ep;
    fa: Brush;
    private eh;
    e2: Brush;
    private aw;
    bf: number;
    private aq;
    ba: number;
    private au;
    bd: number;
    private ao;
    a8: number;
    private el;
    e6: Brush;
    private em;
    e7: Brush;
    destroy(): void;
    private at;
    bc: number;
    private ed;
    ey: Brush;
    private ee;
    ez: Brush;
    private an;
    a7: number;
    private d8;
    et: Brush;
    private d9;
    eu: Brush;
    private ai;
    a5: number;
    private eq;
    fb: Brush;
    private er;
    fc: Brush;
    private a0;
    bj: number;
    private es;
    fd: Brush;
    private ei;
    e3: Brush;
    private ek;
    e5: Brush;
    private ej;
    e4: Brush;
    private as;
    bb: number;
    private ea;
    ev: Brush;
    private ec;
    ex: Brush;
    private eb;
    ew: Brush;
    private am;
    a6: number;
    readonly ab: boolean;
    readonly z: boolean;
    readonly y: boolean;
    readonly aa: boolean;
    q: boolean;
    private m;
    o: FontInfo;
    protected dc(a: string, b: any, c: any): void;
    private dj(a, b, c);
    private dq();
    private dy();
    private dt();
    private d2();
    private d4();
    private d0();
    private dv();
    private dx();
    private df();
    private dh();
    private c5();
    private db();
    provideContainer(a: any): void;
    notifySizeChanged(): void;
    readonly l: DoubleAnimator;
    private k;
    private ak;
    private aj;
    private ar;
    constructor();
    private dn(a);
    private cy();
    private cx(a, b);
    c3(): void;
    private p;
    trackDirty(): void;
    show(): void;
    hide(): void;
}
