import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxFragmentBaseComponent } from "./igx-fragment-base-component";
import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { IgxAnchoredCategorySeriesComponent } from "./igx-anchored-category-series-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { AreaFragment } from "./AreaFragment";
/**
 * Represents one part of a StackedAreaSeries.
*/
export const IgxAreaFragmentComponent_PROVIDERS = [{ provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }];
export class IgxAreaFragmentComponent extends IgxFragmentBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new AreaFragment();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets whether the current series shows an area or line shape.
        */
    get isAreaOrLine() {
        return this.i.ck;
    }
}
IgxAreaFragmentComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-area-fragment',
                template: ``,
                providers: [{ provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxAreaFragmentComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-area-fragment-component.js.map