import { EventEmitter, OnInit } from '@angular/core';
import { PropertyUpdatedEventArgs } from "igniteui-angular-core/ES2015/igx-property-updated-event-args";
import { ColorScale } from "./ColorScale";
/**
 * Base class for classes which provide colors corresponding to numeric values within a known list of numeric values.
*/
export declare const IgxColorScaleComponent_PROVIDERS: any[];
export declare abstract class IgxColorScaleComponent implements OnInit {
    protected createImplementation(): ColorScale;
    ngOnInit(): void;
    protected _implementation: any;
    readonly i: ColorScale;
    private onImplementationCreated();
    constructor();
    private _propertyUpdated;
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    readonly propertyUpdated: EventEmitter<{
        sender: any;
        args: PropertyUpdatedEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
