import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxRingSeriesBaseComponent } from "./igx-ring-series-base-component";
import { HierarchicalRingSeries } from "./HierarchicalRingSeries";
/**
 * Represents a IgxDoughnutChartComponent hierarchical series.
*/
export const IgxHierarchicalRingSeriesComponent_PROVIDERS = [{ provide: IgxRingSeriesBaseComponent, useExisting: forwardRef(() => IgxHierarchicalRingSeriesComponent) }];
export class IgxHierarchicalRingSeriesComponent extends IgxRingSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new HierarchicalRingSeries();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets or sets the property name that contains the children items collection.
        */
    get childrenMemberPath() {
        return this.i.dw;
    }
    set childrenMemberPath(v) {
        this.i.dw = v;
    }
}
IgxHierarchicalRingSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-hierarchical-ring-series',
                template: ``,
                providers: [{ provide: IgxRingSeriesBaseComponent, useExisting: forwardRef(() => IgxHierarchicalRingSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxHierarchicalRingSeriesComponent.ctorParameters = () => [];
IgxHierarchicalRingSeriesComponent.propDecorators = {
    "childrenMemberPath": [{ type: Input },],
};
//# sourceMappingURL=igx-hierarchical-ring-series-component.js.map