import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxContourValueResolverComponent } from "./igx-contour-value-resolver-component";
import { LinearContourValueResolver } from "./LinearContourValueResolver";
/**
 * ContourValueResolver class which resolves contour lines to be distributed at linear intervals from the data minimum to the data maximum.
*/
export const IgxLinearContourValueResolverComponent_PROVIDERS = [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(() => IgxLinearContourValueResolverComponent) }];
export class IgxLinearContourValueResolverComponent extends IgxContourValueResolverComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new LinearContourValueResolver();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets or sets how many contour values to return.
        */
    get valueCount() {
        return this.i.valueCount;
    }
    set valueCount(v) {
        this.i.valueCount = +v;
    }
}
IgxLinearContourValueResolverComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-linear-contour-value-resolver',
                template: ``,
                providers: [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(() => IgxLinearContourValueResolverComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxLinearContourValueResolverComponent.ctorParameters = () => [];
IgxLinearContourValueResolverComponent.propDecorators = {
    "valueCount": [{ type: Input },],
};
//# sourceMappingURL=igx-linear-contour-value-resolver-component.js.map