import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxPolarLineSeriesBaseComponent } from "./igx-polar-line-series-base-component";
import { IgxPolarBaseComponent } from "./igx-polar-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PolarSplineSeries } from "./PolarSplineSeries";
/**
 * Represents a IgxDataChartComponent polar spline series.
*/
export const IgxPolarSplineSeriesComponent_PROVIDERS = [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }];
export class IgxPolarSplineSeriesComponent extends IgxPolarLineSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PolarSplineSeries();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets or sets the Stiffness property.
        */
    get stiffness() {
        return this.i.o6;
    }
    set stiffness(v) {
        this.i.o6 = +v;
    }
}
IgxPolarSplineSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-polar-spline-series',
                template: ``,
                providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxPolarSplineSeriesComponent.ctorParameters = () => [];
IgxPolarSplineSeriesComponent.propDecorators = {
    "stiffness": [{ type: Input },],
};
//# sourceMappingURL=igx-polar-spline-series-component.js.map