import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { UnknownValuePlotting, UnknownValuePlotting_$type } from "igniteui-angular-core/ES2015/UnknownValuePlotting";
import { IgxAnchoredRadialSeriesComponent } from "./igx-anchored-radial-series-component";
import { IgxRadialBaseComponent } from "./igx-radial-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { RadialAreaSeries } from "./RadialAreaSeries";
import { ensureEnum } from "igniteui-angular-core/ES2015/componentUtil";
/**
 * Represents a IgxDataChartComponent radial area series.
*/
export const IgxRadialAreaSeriesComponent_PROVIDERS = [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }];
export class IgxRadialAreaSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RadialAreaSeries();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
    get unknownValuePlotting() {
        return this.i.oj;
    }
    set unknownValuePlotting(v) {
        this.i.oj = ensureEnum(UnknownValuePlotting_$type, v);
    }
}
IgxRadialAreaSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-radial-area-series',
                template: ``,
                providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxRadialAreaSeriesComponent.ctorParameters = () => [];
IgxRadialAreaSeriesComponent.propDecorators = {
    "unknownValuePlotting": [{ type: Input },],
};
//# sourceMappingURL=igx-radial-area-series-component.js.map