import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { Style } from "igniteui-angular-core/ES2015/igx-style";
import { IgxShapeSeriesBaseComponent } from "./igx-shape-series-base-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterPolylineSeries } from "./ScatterPolylineSeries";
import { StyleSelector } from "./StyleSelector";
/**
 * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
*/
export const IgxScatterPolylineSeriesComponent_PROVIDERS = [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent) }];
export class IgxScatterPolylineSeriesComponent extends IgxShapeSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterPolylineSeries();
    }
    get i() {
        return this._implementation;
    }
    /**
         * The StyleSelector which is used to select a style for each Shape.
        */
    get shapeStyleSelector() {
        return this.i.m1;
    }
    set shapeStyleSelector(v) {
        this.i.m1 = v;
    }
    /**
         * The default style to apply to all Shapes in the series.
        */
    get shapeStyle() {
        if (this.i.m6 == null) {
            return null;
        }
        if (!this.i.m6.externalObject) {
            let e = new Style();
            e._implementation = this.i.m6;
            this.i.m6.externalObject = e;
        }
        return this.i.m6.externalObject;
    }
    set shapeStyle(v) {
        v == null ? this.i.m6 = null : this.i.m6 = v.i;
    }
}
IgxScatterPolylineSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-scatter-polyline-series',
                template: ``,
                providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxScatterPolylineSeriesComponent.ctorParameters = () => [];
IgxScatterPolylineSeriesComponent.propDecorators = {
    "shapeStyleSelector": [{ type: Input },],
    "shapeStyle": [{ type: Input },],
};
//# sourceMappingURL=igx-scatter-polyline-series-component.js.map