import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterSeries } from "./ScatterSeries";
/**
 * Represents a IgxDataChartComponent scatter series
*/
export const IgxScatterSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }];
export class IgxScatterSeriesComponent extends IgxScatterBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterSeries();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
    get isMarkerlessDisplayPreferred() {
        return this.i.cy;
    }
}
IgxScatterSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-scatter-series',
                template: ``,
                providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxScatterSeriesComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-scatter-series-component.js.map