import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterSplineSeries } from "./ScatterSplineSeries";
/**
 * Represents a IgxDataChartComponent scatter spline series
*/
export const IgxScatterSplineSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }];
export class IgxScatterSplineSeriesComponent extends IgxScatterBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterSplineSeries();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets or sets the Stiffness property.
        */
    get stiffness() {
        return this.i.oq;
    }
    set stiffness(v) {
        this.i.oq = +v;
    }
}
IgxScatterSplineSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-scatter-spline-series',
                template: ``,
                providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxScatterSplineSeriesComponent.ctorParameters = () => [];
IgxScatterSplineSeriesComponent.propDecorators = {
    "stiffness": [{ type: Input },],
};
//# sourceMappingURL=igx-scatter-spline-series-component.js.map