import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxSplineFragmentBaseComponent } from "./igx-spline-fragment-base-component";
import { IgxSplineSeriesBaseComponent } from "./igx-spline-series-base-component";
import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { IgxAnchoredCategorySeriesComponent } from "./igx-anchored-category-series-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { SplineAreaFragment } from "./SplineAreaFragment";
/**
 * Represents one part of a StackedSplineAreaSeries.
*/
export const IgxSplineAreaFragmentComponent_PROVIDERS = [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }];
export class IgxSplineAreaFragmentComponent extends IgxSplineFragmentBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SplineAreaFragment();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets whether the current series shows an area or line shape.
        */
    get isAreaOrLine() {
        return this.i.ck;
    }
}
IgxSplineAreaFragmentComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-spline-area-fragment',
                template: ``,
                providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxSplineAreaFragmentComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-spline-area-fragment-component.js.map