import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxSplineFragmentBaseComponent } from "./igx-spline-fragment-base-component";
import { IgxSplineSeriesBaseComponent } from "./igx-spline-series-base-component";
import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { IgxAnchoredCategorySeriesComponent } from "./igx-anchored-category-series-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { SplineFragment } from "./SplineFragment";
/**
 * Represents one part of a StackedSplineSeries.
*/
export const IgxSplineFragmentComponent_PROVIDERS = [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }];
export class IgxSplineFragmentComponent extends IgxSplineFragmentBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SplineFragment();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets whether the current series shows an area or line shape.
        */
    get isAreaOrLine() {
        return this.i.ck;
    }
}
IgxSplineFragmentComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-spline-fragment',
                template: ``,
                providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxSplineFragmentComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-spline-fragment-component.js.map