import { Component, Input } from "@angular/core";
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
import { TimeAxisBreak } from "./TimeAxisBreak";
export const IgxTimeAxisBreakComponent_PROVIDERS = [];
export class IgxTimeAxisBreakComponent {
    constructor() {
        this._renderer = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return new TimeAxisBreak();
    }
    ngOnInit() {
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
         * The start time of the axis break.
        */
    get start() {
        return this.i.d;
    }
    set start(v) {
        this.i.d = v;
    }
    /**
         * The end time of the axis break.
        */
    get end() {
        return this.i.c;
    }
    set end(v) {
        this.i.c = v;
    }
    /**
         * The interval at which to repeat this break, expressed as a TimeSpan.
        */
    get interval() {
        return this.i.i;
    }
    set interval(v) {
        this.i.i = +v;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
IgxTimeAxisBreakComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-time-axis-break',
                template: ``,
                providers: IgxTimeAxisBreakComponent_PROVIDERS
            },] },
];
/** @nocollapse */
IgxTimeAxisBreakComponent.ctorParameters = () => [];
IgxTimeAxisBreakComponent.propDecorators = {
    "start": [{ type: Input },],
    "end": [{ type: Input },],
    "interval": [{ type: Input },],
};
//# sourceMappingURL=igx-time-axis-break-component.js.map