import { Component, Input } from "@angular/core";
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
import { TimeAxisInterval } from "./TimeAxisInterval";
import { TimeAxisIntervalType, TimeAxisIntervalType_$type } from "./TimeAxisIntervalType";
import { ensureEnum } from "igniteui-angular-core/ES2015/componentUtil";
export const IgxTimeAxisIntervalComponent_PROVIDERS = [];
export class IgxTimeAxisIntervalComponent {
    constructor() {
        this._renderer = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return new TimeAxisInterval();
    }
    ngOnInit() {
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
         * The visible axis range at which to apply this interval.
        */
    get range() {
        return this.i.k;
    }
    set range(v) {
        this.i.k = +v;
    }
    /**
         * The interval, expressed as a multiple of IntervalType.
        */
    get interval() {
        return this.i.f;
    }
    set interval(v) {
        this.i.f = +v;
    }
    /**
         * The unit of time for this interval.
        */
    get intervalType() {
        return this.i.b;
    }
    set intervalType(v) {
        this.i.b = ensureEnum(TimeAxisIntervalType_$type, v);
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
IgxTimeAxisIntervalComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-time-axis-interval',
                template: ``,
                providers: IgxTimeAxisIntervalComponent_PROVIDERS
            },] },
];
/** @nocollapse */
IgxTimeAxisIntervalComponent.ctorParameters = () => [];
IgxTimeAxisIntervalComponent.propDecorators = {
    "range": [{ type: Input },],
    "interval": [{ type: Input },],
    "intervalType": [{ type: Input },],
};
//# sourceMappingURL=igx-time-axis-interval-component.js.map