import { Component, Input } from "@angular/core";
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
import { TimeAxisLabelFormat } from "./TimeAxisLabelFormat";
export const IgxTimeAxisLabelFormatComponent_PROVIDERS = [];
export class IgxTimeAxisLabelFormatComponent {
    constructor() {
        this._renderer = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return new TimeAxisLabelFormat();
    }
    ngOnInit() {
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
         * The visible axis range at which to apply this label format.
        */
    get range() {
        return this.i.f;
    }
    set range(v) {
        this.i.f = +v;
    }
    /**
         * The DateTime format string to apply.
         * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
        */
    get format() {
        return this.i.b;
    }
    set format(v) {
        this.i.b = v;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
IgxTimeAxisLabelFormatComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-time-axis-label-format',
                template: ``,
                providers: IgxTimeAxisLabelFormatComponent_PROVIDERS
            },] },
];
/** @nocollapse */
IgxTimeAxisLabelFormatComponent.ctorParameters = () => [];
IgxTimeAxisLabelFormatComponent.propDecorators = {
    "range": [{ type: Input },],
    "format": [{ type: Input },],
};
//# sourceMappingURL=igx-time-axis-label-format-component.js.map