/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { Type, markType, Point_$type, enumGetBox, typeCast } from "igniteui-angular-core/ES5/type";
import { isNaN_, intDivide, isInfinity } from "igniteui-angular-core/ES5/number";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { TrendLineType_$type } from "igniteui-angular-core/ES5/TrendLineType";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { PenLineCap_$type } from "igniteui-angular-core/ES5/PenLineCap";
import { DoubleCollection } from "igniteui-angular-core/ES5/DoubleCollection";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-angular-core/ES5/IFastItemsSource";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-angular-core/ES5/Clipper";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
import { stringIsNullOrEmpty } from "igniteui-angular-core/ES5/string";
var AnchoredRadialBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.cs.no;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
export { AnchoredRadialBucketCalculator };
var AnchoredRadialSeries = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.nj = null;
        _this.nn = null;
        _this.oh = { $type: Point_$type, x: 0, y: 0 };
        _this.nl = null;
        _this.nk = null;
        _this.nl = new RadialFrame(3);
        _this.nj = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.bf = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.hn = function () {
        _super.prototype.hn.call(this);
        this.ms = null;
        this.mu = null;
    };
    AnchoredRadialSeries.prototype.im = function (a) {
        _super.prototype.im.call(this, a);
        this.ni = a;
    };
    AnchoredRadialSeries.prototype.fb = function (a, b) {
        return this.fc(a, b, this.ms, null, this.no);
    };
    AnchoredRadialSeries.prototype.e9 = function (a, b) {
        return this.fa(a, b, this.ms, null, this.no);
    };
    AnchoredRadialSeries.prototype.d6 = function (a, b, c, d, e) {
        if (this.no == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.d7(a, b, this.ms, d, e, this.no.count, null);
    };
    AnchoredRadialSeries.prototype.ek = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nt(this.ms, this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.ms.b8, d);
        f.c = this.bs.m0;
        return this.em(this.no, a, this.ms, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.ld = function (a, b, c) {
        if (this.mu == null || this.ms == null || this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bi.bs, this.bi.br, this.mu.b8, d);
        e.c = this.getEffectiveViewport1(this.bi);
        var f = this.ek(a, b, c);
        f = this.mu.dt(f, e);
        var g = this.mv.c(a);
        if (!b && this.ms != null) {
            var h = this.fb(a, c);
            var i = this.e9(a, c);
            var j = this.nt(this.ms, this.bi.bs, this.bi.br, d);
            var k = new ScalerParams(0, this.bi.bs, this.bi.br, this.ms.b8, d);
            k.c = this.bs.m0;
            var l = this.d6(a, h, this.ms, k, j);
            var m = this.d6(a, i, this.ms, k, j);
            if (m <= l) {
                g = this.ms.dt(i, k) + j;
            }
            else {
                g = this.ms.dt(h, k) + j;
            }
        }
        var n = this.mv.d(g, f, this.bi.bs, this.bi.br);
        var o = this.mv.e(g, f, this.bi.bs, this.bi.br);
        return { $type: Point_$type, x: n, y: o };
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "no", {
        get: function () {
            return this.nn;
        },
        set: function (a) {
            if (this.nn != a) {
                var b = this.nn;
                this.nn = a;
                this.raisePropertyChanged("ValueColumn", b, this.nn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredRadialSeries.prototype, "od", {
        get: function () {
            return this.c(AnchoredRadialSeries.n4);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.n4, a);
        },
        enumerable: true,
        configurable: true
    });
    AnchoredRadialSeries.prototype.an = function (a) {
        if (a != null && a == this.ms && this.no != null && this.no.count > 0) {
            return new AxisRange(0, this.no.count - 1);
        }
        if (a != null && a == this.mu && this.no != null && this.no.count > 0) {
            return new AxisRange(this.no.minimum, this.no.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.is = function (a, b, c, d) {
        _super.prototype.is.call(this, a, b, c, d);
        if (this.ni.ct.g$b(a, b, c, d)) {
            this.i5(false);
            this.ic();
        }
        var e = typeCast(NumericAxisBase.$, this.mu);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.no);
                    this.no = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.no = this.bw(this.n0);
                    this.ni.co.e(this.er);
                }
                if (e != null && !e.ck()) {
                    this.ni.co.e(this.er);
                    this.i5(false);
                }
                break;
            case AnchoredRadialSeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.no);
                    this.no = this.bw(this.n0);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.ck()) {
                    this.ni.co.e(this.er);
                    this.i5(false);
                }
                break;
            case "TrendLineBrush":
                this.jg();
                break;
            case "TrendLineType":
                this.ic();
                break;
        }
    };
    AnchoredRadialSeries.prototype.hs = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.ni.co.e(this.er);
                break;
        }
        this.ni.ct.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.mu != null && !this.mu.ck()) {
                    this.i5(true);
                }
                break;
            case 1:
                if (this.mu != null && !this.mu.ck()) {
                    this.i5(true);
                }
                break;
            case 0:
                if (this.mu != null && !this.mu.ck()) {
                    this.i5(true);
                }
                break;
            case 2:
                if (this.n0 != null && this.ni.co.b > 0 && this.mu != null && !this.mu.ck()) {
                    this.i5(true);
                }
                break;
            case 3:
                if (d == this.n0) {
                    if (this.mu != null && !this.mu.ck()) {
                        this.i5(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.dv = function (a, b, c) {
        var d = _super.prototype.dv.call(this, a, b, c);
        var e = c;
        if (this.bz == null || this.bz.count == 0 || this.ms == null || this.no == null || this.ms.jr == 0 || this.mu == null || isInfinity(this.mu.jx) || isInfinity(this.mu.jw) || e.co.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.nt(this.ms, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.ms.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    AnchoredRadialSeries.prototype.get_nr = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "nr", {
        get: function () {
            return this.get_nr();
        },
        enumerable: true,
        configurable: true
    });
    AnchoredRadialSeries.prototype.nt = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.m7(), b, c, d);
                break;
        }
        if (a.b8) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.nc = function (a, b) {
        var _this = this;
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.ms;
        var g = this.mu;
        var h = g.jx;
        var i = g.jw;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = this.lv();
        var k = 0;
        var l = b;
        var m = new CollisionAvoider();
        var n = 0;
        var o = b.co.d;
        n = this.nt(f, c, d, e);
        l.ct.q = this.mu.lc;
        l.ct.p = this.mu.lb;
        l.ct.r = function (p, q) { return _this.nu(p, q, c, d); };
        l.ct.s = function (p, q) { return _this.nv(p, q, c, d); };
        var p = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        var q = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = b.co.b;
            $ret.d = b.co.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = _this.er;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.ct.t(a.p, this.nm, this.no, this.nx, function (r) { return _this.ms.getScaledAngle(r); }, function (r) { return _this.mu.li(r); }, q, p);
        var r = true;
        if (this.ns(b)) {
            o--;
        }
        for (var s = b.co.c; s <= o; ++s) {
            var t = s;
            if (t * b.co.b >= this.ms.jr) {
                t -= intDivide((this.ms.jr), b.co.b);
            }
            var u = b.co.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.li(u[1]);
                if (b.co.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.li(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.nr && this.nq()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    var v = Math.min(t * b.co.b, this.bz.count - 1);
                    var w = this.mv.d(u[0], u[1], c, d);
                    var x = this.mv.e(u[0], u[1], c, d);
                    var y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        var z = b.cp.item(k);
                        z.ak = v;
                        z.content.item = this.bz.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.nr && this.nq()) {
                    o++;
                }
            }
        }
        b.cp.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.nu = function (a, b, c, d) {
        return this.mv.d(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.nv = function (a, b, c, d) {
        return this.mv.e(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.ns = function (a) {
        var b = a;
        return !this.nr && b.co.c == 0 && b.co.d == this.ms.jr;
    };
    AnchoredRadialSeries.prototype.nh = function (a, b, c) {
        var d = null;
        var e = c.bs;
        var f = c.br;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.n3 = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.np()) {
                a.add(this.oh);
                a.add(a._inner[0]);
                d.add(this.oh);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.nq = function () {
        return !this.np();
    };
    AnchoredRadialSeries.prototype.np = function () {
        var a = this.bi.bs;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.hp = function (a, b) {
        _super.prototype.hp.call(this, a, b);
        var c = b;
        if (a) {
            c.cp.clear();
        }
        c.ct.g$d();
    };
    AnchoredRadialSeries.prototype.nd = function (a, b) {
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.li(b);
        var g = b;
        g.ct.g$g(a.p);
        CategoryMarkerManager.b(this, a.m, g.cp, this.lx);
        g.cj();
        this.n2(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.n2 = function (a, b, c, d, e) {
        e.cu(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.jg = function () {
        _super.prototype.jg.call(this);
        if (this.fe < 0) {
            return;
        }
        this.ni.cv();
    };
    AnchoredRadialSeries.prototype.fq = function (a, b) {
        if (a == this.ni.ct.g$j) {
            return null;
        }
        return _super.prototype.fq.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.c8 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.ms == null || this.no == null || this.mu == null) {
            return false;
        }
        if (d < 0 || d > this.no.count - 1) {
            return false;
        }
        var e = this.ms.getScaledAngle(d);
        var f = this.mu.li(this.no.item(d));
        if (isNaN_(f)) {
            f = (this.mu.lb + this.mu.lc) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.i7 = function (a, b) {
        _super.prototype.i7.call(this, a, b);
        if (!this.dk) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.bh);
        c.co.e(this.er);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.de) {
            this.nl = new RadialFrame(3);
            this.nc(this.nl, c);
        }
        this.de = false;
        this.nd(this.nl, c);
        this.dk = false;
    };
    AnchoredRadialSeries.prototype.i4 = function (a, b, c, d, e) {
        _super.prototype.i4.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        g.co.e(this.er);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.nk == null) {
            this.nk = new RadialFrame(3);
        }
        this.nk.u();
        this.nc(this.nk, g);
        this.nd(this.nk, g);
    };
    AnchoredRadialSeries.prototype.hy = function (a) {
        _super.prototype.hy.call(this, a);
        this.a2.exportTrendlineData(this, a, this.ni.ct.g$j);
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.n4 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    return AnchoredRadialSeries;
}(RadialBase));
export { AnchoredRadialSeries };
Type.dep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:n0:oc', [2, null], 'TrendLineType:nm:oa', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:nw:n9', [1, 1.5], 'TrendLinePeriod:nx:n8', [1, 7], 'TrendLineZIndex:ny:ob', [1, 1], 'TrendLineBrush:oe:n5', [Brush.$, null], 'TrendLineDashArray:of:n6', [DoubleCollection.$], 'TrendLineDashCap:og:n7', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
var AnchoredRadialSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cs = null;
        _this.ct = null;
        _this.co = new AnchoredRadialBucketCalculator(_this);
        _this.cs = a;
        _this.ct = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.cu = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.cv = function () {
        this.cs.od = null;
        if (this.cs.oe != null) {
            this.cs.od = this.cs.oe;
        }
        else {
            this.cs.od = this.cs.kv;
        }
    };
    AnchoredRadialSeriesView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cs.nm != 0 && !b) {
                var c = this.ct.g$j;
                c.ac = this.cs.nw;
                c._stroke = this.cs.od;
                c.ai = this.cs.of;
                c.ad = this.cs.og;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cs.ms.e2 != null) {
            a += "<span>${item." + this.cs.ms.e2 + "}</span><br/>";
        }
        a += "<span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cs.fs + ": </span><span class='ui-priority-primary'>" + "${item." + this.cs.n0 + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));
export { AnchoredRadialSeriesView };
//# sourceMappingURL=AnchoredRadialBucketCalculator_combined.js.map