import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxSizeScaleComponent } from "./igx-size-scale-component";
import { IgxBrushScaleComponent } from "./igx-brush-scale-component";
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { BubbleSeries } from "./BubbleSeries";
/**
 * Represents a IgxDataChartComponent bubble series.
*/
export var IgxBubbleSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxBubbleSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxBubbleSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxBubbleSeriesComponent; }) }];
var IgxBubbleSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxBubbleSeriesComponent, _super);
    function IgxBubbleSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxBubbleSeriesComponent.prototype.createImplementation = function () {
        return new BubbleSeries();
    };
    Object.defineProperty(IgxBubbleSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxBubbleSeriesComponent.prototype, "radiusMemberPath", {
        /**
         * Gets or sets the radius mapping property for the current series object.
        */
        get: /**
             * Gets or sets the radius mapping property for the current series object.
            */
        function () {
            return this.i.pa;
        },
        set: function (v) {
            this.i.pa = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxBubbleSeriesComponent.prototype, "radiusScale", {
        /**
         * Gets or sets the radius size scale for the bubbles.
        */
        get: /**
             * Gets or sets the radius size scale for the bubbles.
            */
        function () {
            if (this.i.or == null) {
                return null;
            }
            if (!this.i.or.externalObject) {
                var e = new IgxSizeScaleComponent();
                e._implementation = this.i.or;
                this.i.or.externalObject = e;
            }
            return this.i.or.externalObject;
        },
        set: function (v) {
            v == null ? this.i.or = null : this.i.or = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxBubbleSeriesComponent.prototype, "labelMemberPath", {
        /**
         * Gets or sets the Label mapping property for the current series object.
        */
        get: /**
             * Gets or sets the Label mapping property for the current series object.
            */
        function () {
            return this.i.o7;
        },
        set: function (v) {
            this.i.o7 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxBubbleSeriesComponent.prototype, "fillMemberPath", {
        /**
         * Gets or sets the fill mapping property for the current series object.
        */
        get: /**
             * Gets or sets the fill mapping property for the current series object.
            */
        function () {
            return this.i.o3;
        },
        set: function (v) {
            this.i.o3 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxBubbleSeriesComponent.prototype, "fillScale", {
        /**
         * Gets or sets the brush scale for the marker brush.
        */
        get: /**
             * Gets or sets the brush scale for the marker brush.
            */
        function () {
            if (this.i.op == null) {
                return null;
            }
            if (!this.i.op.externalObject) {
                var e = new IgxBrushScaleComponent();
                e._implementation = this.i.op;
                this.i.op.externalObject = e;
            }
            return this.i.op.externalObject;
        },
        set: function (v) {
            v == null ? this.i.op = null : this.i.op = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxBubbleSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
        /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
        get: /**
             * Overridden by derived series classes to indicate when markerless display is preferred or not.
            */
        function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    IgxBubbleSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-bubble-series',
                    template: "",
                    providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxBubbleSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxBubbleSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxBubbleSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxBubbleSeriesComponent.ctorParameters = function () { return []; };
    IgxBubbleSeriesComponent.propDecorators = {
        "radiusMemberPath": [{ type: Input },],
        "radiusScale": [{ type: Input },],
        "labelMemberPath": [{ type: Input },],
        "fillMemberPath": [{ type: Input },],
        "fillScale": [{ type: Input },],
    };
    return IgxBubbleSeriesComponent;
}(IgxScatterBaseComponent));
export { IgxBubbleSeriesComponent };
//# sourceMappingURL=igx-bubble-series-component.js.map