import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxCategoryAxisBaseComponent } from "./igx-category-axis-base-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { CategoryYAxis } from "./CategoryYAxis";
import { toPoint, fromRect } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Represents a IgxDataChartComponent category Y axis.
*/
export var IgxCategoryYAxisComponent_PROVIDERS = [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(function () { return IgxCategoryYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxCategoryYAxisComponent; }) }];
var IgxCategoryYAxisComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxCategoryYAxisComponent, _super);
    function IgxCategoryYAxisComponent() {
        return _super.call(this) || this;
    }
    IgxCategoryYAxisComponent.prototype.createImplementation = function () {
        return new CategoryYAxis();
    };
    Object.defineProperty(IgxCategoryYAxisComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryYAxisComponent.prototype, "isVertical", {
        /**
         * Gets if the current axis is a vertical axis.
        */
        get: /**
             * Gets if the current axis is a vertical axis.
            */
        function () {
            return this.i.ce;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryYAxisComponent.prototype, "interval", {
        /**
         * Gets or sets the frequency of displayed labels.
         * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
        */
        get: /**
             * Gets or sets the frequency of displayed labels.
             * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
            */
        function () {
            return this.i.kw;
        },
        set: function (v) {
            this.i.kw = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryYAxisComponent.prototype, "actualInterval", {
        /**
         * Gets the effective value for the current Interval.
        */
        get: /**
             * Gets the effective value for the current Interval.
            */
        function () {
            return this.i.ks;
        },
        set: function (v) {
            this.i.ks = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryYAxisComponent.prototype, "minorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines.
         * The set value is a factor that determines how the minor lines will be displayed.
        */
        get: /**
             * Gets or sets the frequency of displayed minor lines.
             * The set value is a factor that determines how the minor lines will be displayed.
            */
        function () {
            return this.i.kx;
        },
        set: function (v) {
            this.i.kx = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryYAxisComponent.prototype, "actualMinorInterval", {
        /**
         * Gets the effective value for the current MinorInterval.
        */
        get: /**
             * Gets the effective value for the current MinorInterval.
            */
        function () {
            return this.i.ku;
        },
        set: function (v) {
            this.i.ku = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxCategoryYAxisComponent.prototype.getCategoryBoundingBox = function (point, useInterpolation, singularWidth) {
        var iv = this.i.kn(toPoint(point), useInterpolation, singularWidth);
        return fromRect(iv);
    };
    IgxCategoryYAxisComponent.prototype.scrollRangeIntoView = function (minimum, maximum) {
        this.i.k7(minimum, maximum);
    };
    /**
     * Scrolls the specified item into view.
    
    * @param item  * Data item to scroll into view
    */
    /**
         * Scrolls the specified item into view.
        
        * @param item  * Data item to scroll into view
        */
    IgxCategoryYAxisComponent.prototype.scrollIntoView = /**
         * Scrolls the specified item into view.
        
        * @param item  * Data item to scroll into view
        */
    function (item) {
        this.i.k6(item);
    };
    IgxCategoryYAxisComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-category-y-axis',
                    template: "",
                    providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(function () { return IgxCategoryYAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxCategoryYAxisComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxCategoryYAxisComponent.ctorParameters = function () { return []; };
    IgxCategoryYAxisComponent.propDecorators = {
        "interval": [{ type: Input },],
        "actualInterval": [{ type: Input },],
        "minorInterval": [{ type: Input },],
        "actualMinorInterval": [{ type: Input },],
    };
    return IgxCategoryYAxisComponent;
}(IgxCategoryAxisBaseComponent));
export { IgxCategoryYAxisComponent };
//# sourceMappingURL=igx-category-y-axis-component.js.map