import { EventEmitter, Output } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core/ES5/type";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core/ES5/igx-property-updated-event-args";
/**
 * Base class for classes which provide colors corresponding to numeric values within a known list of numeric values.
*/
export var IgxColorScaleComponent_PROVIDERS = [];
var IgxColorScaleComponent = /** @class */ (function () {
    function IgxColorScaleComponent() {
        this._propertyUpdated = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxColorScaleComponent.prototype.createImplementation = function () {
        return null;
    };
    IgxColorScaleComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxColorScaleComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxColorScaleComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxColorScaleComponent.prototype, "propertyUpdated", {
        get: /**
             * Event raised when a property (including "effective" and non-dependency property) value changes.
            */
        function () {
            var _this = this;
            if (this._propertyUpdated == null) {
                this._propertyUpdated = new EventEmitter();
                this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new PropertyUpdatedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforePropertyUpdated) {
                            _this.beforePropertyUpdated(_this, outerArgs);
                        }
                        _this._propertyUpdated.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._propertyUpdated;
        },
        enumerable: true,
        configurable: true
    });
    IgxColorScaleComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxColorScaleComponent.propDecorators = {
        "propertyUpdated": [{ type: Output },],
    };
    return IgxColorScaleComponent;
}());
export { IgxColorScaleComponent };
//# sourceMappingURL=igx-color-scale-component.js.map