import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { BrushSelectionMode, BrushSelectionMode_$type } from "./BrushSelectionMode";
import { IgxBrushScaleComponent } from "./igx-brush-scale-component";
import { CustomPaletteBrushScale } from "./CustomPaletteBrushScale";
import { ensureEnum, brushToString } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Represents a brush scale that uses index-based brush selection mode.
*/
export var IgxCustomPaletteBrushScaleComponent_PROVIDERS = [{ provide: IgxBrushScaleComponent, useExisting: forwardRef(function () { return IgxCustomPaletteBrushScaleComponent; }) }];
var IgxCustomPaletteBrushScaleComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxCustomPaletteBrushScaleComponent, _super);
    function IgxCustomPaletteBrushScaleComponent() {
        return _super.call(this) || this;
    }
    IgxCustomPaletteBrushScaleComponent.prototype.createImplementation = function () {
        return new CustomPaletteBrushScale();
    };
    Object.defineProperty(IgxCustomPaletteBrushScaleComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCustomPaletteBrushScaleComponent.prototype, "brushSelectionMode", {
        /**
         * Gets or sets the brush selection mode.
        */
        get: /**
             * Gets or sets the brush selection mode.
            */
        function () {
            return this.i.brushSelectionMode;
        },
        set: function (v) {
            this.i.brushSelectionMode = ensureEnum(BrushSelectionMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCustomPaletteBrushScaleComponent.prototype, "isReady", {
        /**
         * Checks if this scale is ready for useage with a series
        */
        get: /**
             * Checks if this scale is ready for useage with a series
            */
        function () {
            return this.i.isReady;
        },
        enumerable: true,
        configurable: true
    });
    IgxCustomPaletteBrushScaleComponent.prototype.getBrush1 = function (index, total) {
        var iv = this.i.getBrush1(index, total);
        return brushToString(iv);
    };
    IgxCustomPaletteBrushScaleComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-custom-palette-brush-scale',
                    template: "",
                    providers: [{ provide: IgxBrushScaleComponent, useExisting: forwardRef(function () { return IgxCustomPaletteBrushScaleComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxCustomPaletteBrushScaleComponent.ctorParameters = function () { return []; };
    IgxCustomPaletteBrushScaleComponent.propDecorators = {
        "brushSelectionMode": [{ type: Input },],
    };
    return IgxCustomPaletteBrushScaleComponent;
}(IgxBrushScaleComponent));
export { IgxCustomPaletteBrushScaleComponent };
//# sourceMappingURL=igx-custom-palette-brush-scale-component.js.map