import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxContourValueResolverComponent } from "./igx-contour-value-resolver-component";
import { LinearContourValueResolver } from "./LinearContourValueResolver";
/**
 * ContourValueResolver class which resolves contour lines to be distributed at linear intervals from the data minimum to the data maximum.
*/
export var IgxLinearContourValueResolverComponent_PROVIDERS = [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(function () { return IgxLinearContourValueResolverComponent; }) }];
var IgxLinearContourValueResolverComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxLinearContourValueResolverComponent, _super);
    function IgxLinearContourValueResolverComponent() {
        return _super.call(this) || this;
    }
    IgxLinearContourValueResolverComponent.prototype.createImplementation = function () {
        return new LinearContourValueResolver();
    };
    Object.defineProperty(IgxLinearContourValueResolverComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLinearContourValueResolverComponent.prototype, "valueCount", {
        /**
         * Gets or sets how many contour values to return.
        */
        get: /**
             * Gets or sets how many contour values to return.
            */
        function () {
            return this.i.valueCount;
        },
        set: function (v) {
            this.i.valueCount = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxLinearContourValueResolverComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-linear-contour-value-resolver',
                    template: "",
                    providers: [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(function () { return IgxLinearContourValueResolverComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxLinearContourValueResolverComponent.ctorParameters = function () { return []; };
    IgxLinearContourValueResolverComponent.propDecorators = {
        "valueCount": [{ type: Input },],
    };
    return IgxLinearContourValueResolverComponent;
}(IgxContourValueResolverComponent));
export { IgxLinearContourValueResolverComponent };
//# sourceMappingURL=igx-linear-contour-value-resolver-component.js.map