import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { UnknownValuePlotting, UnknownValuePlotting_$type } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { IgxPolarLineSeriesBaseComponent } from "./igx-polar-line-series-base-component";
import { IgxPolarBaseComponent } from "./igx-polar-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PolarLineSeries } from "./PolarLineSeries";
import { ensureEnum } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Represents a IgxDataChartComponent polar line series.
*/
export var IgxPolarLineSeriesComponent_PROVIDERS = [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPolarLineSeriesComponent; }) }];
var IgxPolarLineSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxPolarLineSeriesComponent, _super);
    function IgxPolarLineSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxPolarLineSeriesComponent.prototype.createImplementation = function () {
        return new PolarLineSeries();
    };
    Object.defineProperty(IgxPolarLineSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPolarLineSeriesComponent.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            */
        function () {
            return this.i.o6;
        },
        set: function (v) {
            this.i.o6 = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgxPolarLineSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-polar-line-series',
                    template: "",
                    providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxPolarLineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPolarLineSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxPolarLineSeriesComponent.ctorParameters = function () { return []; };
    IgxPolarLineSeriesComponent.propDecorators = {
        "unknownValuePlotting": [{ type: Input },],
    };
    return IgxPolarLineSeriesComponent;
}(IgxPolarLineSeriesBaseComponent));
export { IgxPolarLineSeriesComponent };
//# sourceMappingURL=igx-polar-line-series-component.js.map