import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { UnknownValuePlotting, UnknownValuePlotting_$type } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { IgxAnchoredRadialSeriesComponent } from "./igx-anchored-radial-series-component";
import { IgxRadialBaseComponent } from "./igx-radial-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { RadialAreaSeries } from "./RadialAreaSeries";
import { ensureEnum } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Represents a IgxDataChartComponent radial area series.
*/
export var IgxRadialAreaSeriesComponent_PROVIDERS = [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }];
var IgxRadialAreaSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxRadialAreaSeriesComponent, _super);
    function IgxRadialAreaSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxRadialAreaSeriesComponent.prototype.createImplementation = function () {
        return new RadialAreaSeries();
    };
    Object.defineProperty(IgxRadialAreaSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxRadialAreaSeriesComponent.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: /**
             * Determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            */
        function () {
            return this.i.oj;
        },
        set: function (v) {
            this.i.oj = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgxRadialAreaSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-radial-area-series',
                    template: "",
                    providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxRadialAreaSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxRadialAreaSeriesComponent.ctorParameters = function () { return []; };
    IgxRadialAreaSeriesComponent.propDecorators = {
        "unknownValuePlotting": [{ type: Input },],
    };
    return IgxRadialAreaSeriesComponent;
}(IgxAnchoredRadialSeriesComponent));
export { IgxRadialAreaSeriesComponent };
//# sourceMappingURL=igx-radial-area-series-component.js.map