/**
 * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
*
* Class containing several properties which are used as parameters passed to scaling operations in a `IgxSeriesViewerComponent`.
*/
var /**
 * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
*
* Class containing several properties which are used as parameters passed to scaling operations in a `IgxSeriesViewerComponent`.
*/
ScalerParams = /** @class */ (function () {
    function ScalerParams() {
    }
    Object.defineProperty(ScalerParams.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    ScalerParams.prototype.onImplementationCreated = function () {
    };
    ScalerParams.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(ScalerParams.prototype, "referenceValue", {
        /**
         * The series reference value.
         * Typically, the reference value is the initial value of the series.  The reference value is used by the PercentChangeYAxis, where all values in the series are scaled relative to the initial value.
        */
        get: /**
             * The series reference value.
             * Typically, the reference value is the initial value of the series.  The reference value is used by the PercentChangeYAxis, where all values in the series are scaled relative to the initial value.
            */
        function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: true,
        configurable: true
    });
    return ScalerParams;
}());
/**
 * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
*
* Class containing several properties which are used as parameters passed to scaling operations in a `IgxSeriesViewerComponent`.
*/
export { ScalerParams };
//# sourceMappingURL=igx-scaler-params.js.map