import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { Style } from "igniteui-angular-core/ES5/igx-style";
import { IgxShapeSeriesBaseComponent } from "./igx-shape-series-base-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterPolylineSeries } from "./ScatterPolylineSeries";
import { StyleSelector } from "./StyleSelector";
/**
 * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
*/
export var IgxScatterPolylineSeriesComponent_PROVIDERS = [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(function () { return IgxScatterPolylineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterPolylineSeriesComponent; }) }];
var IgxScatterPolylineSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxScatterPolylineSeriesComponent, _super);
    function IgxScatterPolylineSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxScatterPolylineSeriesComponent.prototype.createImplementation = function () {
        return new ScatterPolylineSeries();
    };
    Object.defineProperty(IgxScatterPolylineSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxScatterPolylineSeriesComponent.prototype, "shapeStyleSelector", {
        /**
         * The StyleSelector which is used to select a style for each Shape.
        */
        get: /**
             * The StyleSelector which is used to select a style for each Shape.
            */
        function () {
            return this.i.m1;
        },
        set: function (v) {
            this.i.m1 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxScatterPolylineSeriesComponent.prototype, "shapeStyle", {
        /**
         * The default style to apply to all Shapes in the series.
        */
        get: /**
             * The default style to apply to all Shapes in the series.
            */
        function () {
            if (this.i.m6 == null) {
                return null;
            }
            if (!this.i.m6.externalObject) {
                var e = new Style();
                e._implementation = this.i.m6;
                this.i.m6.externalObject = e;
            }
            return this.i.m6.externalObject;
        },
        set: function (v) {
            v == null ? this.i.m6 = null : this.i.m6 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    IgxScatterPolylineSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-scatter-polyline-series',
                    template: "",
                    providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(function () { return IgxScatterPolylineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterPolylineSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxScatterPolylineSeriesComponent.ctorParameters = function () { return []; };
    IgxScatterPolylineSeriesComponent.propDecorators = {
        "shapeStyleSelector": [{ type: Input },],
        "shapeStyle": [{ type: Input },],
    };
    return IgxScatterPolylineSeriesComponent;
}(IgxShapeSeriesBaseComponent));
export { IgxScatterPolylineSeriesComponent };
//# sourceMappingURL=igx-scatter-polyline-series-component.js.map