import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterSeries } from "./ScatterSeries";
/**
 * Represents a IgxDataChartComponent scatter series
*/
export var IgxScatterSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }];
var IgxScatterSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxScatterSeriesComponent, _super);
    function IgxScatterSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxScatterSeriesComponent.prototype.createImplementation = function () {
        return new ScatterSeries();
    };
    Object.defineProperty(IgxScatterSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxScatterSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
        /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
        get: /**
             * Overridden by derived series classes to indicate when markerless display is preferred or not.
            */
        function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    IgxScatterSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-scatter-series',
                    template: "",
                    providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxScatterSeriesComponent.ctorParameters = function () { return []; };
    return IgxScatterSeriesComponent;
}(IgxScatterBaseComponent));
export { IgxScatterSeriesComponent };
//# sourceMappingURL=igx-scatter-series-component.js.map