import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterSplineSeries } from "./ScatterSplineSeries";
/**
 * Represents a IgxDataChartComponent scatter spline series
*/
export var IgxScatterSplineSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }];
var IgxScatterSplineSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxScatterSplineSeriesComponent, _super);
    function IgxScatterSplineSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxScatterSplineSeriesComponent.prototype.createImplementation = function () {
        return new ScatterSplineSeries();
    };
    Object.defineProperty(IgxScatterSplineSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxScatterSplineSeriesComponent.prototype, "stiffness", {
        /**
         * Gets or sets the Stiffness property.
        */
        get: /**
             * Gets or sets the Stiffness property.
            */
        function () {
            return this.i.oq;
        },
        set: function (v) {
            this.i.oq = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxScatterSplineSeriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-scatter-spline-series',
                    template: "",
                    providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSplineSeriesComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxScatterSplineSeriesComponent.ctorParameters = function () { return []; };
    IgxScatterSplineSeriesComponent.propDecorators = {
        "stiffness": [{ type: Input },],
    };
    return IgxScatterSplineSeriesComponent;
}(IgxScatterBaseComponent));
export { IgxScatterSplineSeriesComponent };
//# sourceMappingURL=igx-scatter-spline-series-component.js.map