import { OnInit } from '@angular/core';
import { ScatterTriangulationSeries } from "igniteui-angular-charts/ES5/ScatterTriangulationSeries";
import { IgxNumericXAxisComponent } from "igniteui-angular-charts/ES5/igx-numeric-x-axis-component";
import { IgxNumericYAxisComponent } from "igniteui-angular-charts/ES5/igx-numeric-y-axis-component";
import { IgxSeriesComponent } from './igx-series-component';
/**
 * Represents a IgxScatterTriangulationSeriesComponent base series.
*/
export declare const IgxScatterTriangulationSeriesComponent_PROVIDERS: any[];
export declare abstract class IgxScatterTriangulationSeriesComponent extends IgxSeriesComponent implements OnInit {
    protected createImplementation(): ScatterTriangulationSeries;
    ngOnInit(): void;
    private _trianglesSource;
    trianglesSource: Array<any>;
    bindData(): void;
    protected _implementation: any;
    readonly i: ScatterTriangulationSeries;
    static _createFromInternal(internal: any): IgxScatterTriangulationSeriesComponent;
    /**
 * The name of the property from which to extract the X-coordinate for each item in the ItemsSource.
*/
    xMemberPath: string;
    /**
     * The name of the property from which to extract the Y-coordinate for each item in the ItemsSource.
    */
    yMemberPath: string;
    /**
     * The X-Axis for this series.
    */
    xAxis: IgxNumericXAxisComponent;
    /**
     * The Y-Axis for this series.
    */
    yAxis: IgxNumericYAxisComponent;
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the first vertex point in the ItemsSource.
    */
    triangleVertexMemberPath1: string;
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the second vertex point in the ItemsSource.
    */
    triangleVertexMemberPath2: string;
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the third vertex point in the ItemsSource.
    */
    triangleVertexMemberPath3: string;
    /**
     * Gets whether or not this series is a shape series
    */
    readonly isShape: boolean;
    /**
 * Determine if object can be used as YAxis

* @param axis  * The object to check
*/
    canUseAsYAxis(axis: any): boolean;
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis: any): boolean;
}
