import { EventEmitter, Output, Component, Input, ChangeDetectionStrategy } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core/ES5/type";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core/ES5/igx-property-updated-event-args";
import { SizeScale } from "./SizeScale";
import { ensureBool } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Represents a scale that is used determine an object's size.
*/
export var IgxSizeScaleComponent_PROVIDERS = [];
var IgxSizeScaleComponent = /** @class */ (function () {
    function IgxSizeScaleComponent() {
        this._propertyUpdated = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxSizeScaleComponent.prototype.createImplementation = function () {
        return new SizeScale();
    };
    IgxSizeScaleComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxSizeScaleComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxSizeScaleComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxSizeScaleComponent.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value for this scale.
        */
        get: /**
             * Gets or sets the minimum value for this scale.
            */
        function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSizeScaleComponent.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value for this scale.
        */
        get: /**
             * Gets or sets the maximum value for this scale.
            */
        function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSizeScaleComponent.prototype, "isLogarithmic", {
        /**
         * Gets or sets whether the scale is logarithmic.
        */
        get: /**
             * Gets or sets whether the scale is logarithmic.
            */
        function () {
            return this.i.isLogarithmic;
        },
        set: function (v) {
            this.i.isLogarithmic = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSizeScaleComponent.prototype, "logarithmBase", {
        /**
         * Gets or sets the logarithm base for this scale.
        */
        get: /**
             * Gets or sets the logarithm base for this scale.
            */
        function () {
            return this.i.logarithmBase;
        },
        set: function (v) {
            this.i.logarithmBase = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSizeScaleComponent.prototype, "propertyUpdated", {
        get: /**
             * Event raised when a property (including "effective" and non-dependency property) value changes.
            */
        function () {
            var _this = this;
            if (this._propertyUpdated == null) {
                this._propertyUpdated = new EventEmitter();
                this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new PropertyUpdatedEventArgs();
                        outerArgs._provideImplementation(e);
                        if (_this.beforePropertyUpdated) {
                            _this.beforePropertyUpdated(_this, outerArgs);
                        }
                        _this._propertyUpdated.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._propertyUpdated;
        },
        enumerable: true,
        configurable: true
    });
    IgxSizeScaleComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxSizeScaleComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-size-scale',
                    template: "",
                    providers: [],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxSizeScaleComponent.ctorParameters = function () { return []; };
    IgxSizeScaleComponent.propDecorators = {
        "minimumValue": [{ type: Input },],
        "maximumValue": [{ type: Input },],
        "isLogarithmic": [{ type: Input },],
        "logarithmBase": [{ type: Input },],
        "propertyUpdated": [{ type: Output },],
    };
    return IgxSizeScaleComponent;
}());
export { IgxSizeScaleComponent };
//# sourceMappingURL=igx-size-scale-component.js.map