import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { IgxCategoryAxisBaseComponent } from "./igx-category-axis-base-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { ensureBool } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Represents an category-based horizontal X axis that uses a DateTime scale.
*/
export var IgxTimeAxisBaseComponent_PROVIDERS = [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(function () { return IgxTimeAxisBaseComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxTimeAxisBaseComponent; }) }];
var IgxTimeAxisBaseComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTimeAxisBaseComponent, _super);
    function IgxTimeAxisBaseComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "dateTimeMemberPath", {
        /**
         * Gets or sets the DateTime mapping property for the axis.
        */
        get: /**
             * Gets or sets the DateTime mapping property for the axis.
            */
        function () {
            return this.i.dateTimeMemberPath;
        },
        set: function (v) {
            this.i.dateTimeMemberPath = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "isDataPreSorted", {
        /**
         * Gets or sets whether the data assigned to the date time axis should be considered pre-sorted by date/time.
        */
        get: /**
             * Gets or sets whether the data assigned to the date time axis should be considered pre-sorted by date/time.
            */
        function () {
            return this.i.kv;
        },
        set: function (v) {
            this.i.kv = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "actualMinimumValue", {
        /**
         * Gets the coerced minimum value.
        */
        get: /**
             * Gets the coerced minimum value.
            */
        function () {
            return this.i.actualMinimumValue;
        },
        set: function (v) {
            this.i.actualMinimumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "actualMaximumValue", {
        /**
         * Gets the coerced maximum value.
        */
        get: /**
             * Gets the coerced maximum value.
            */
        function () {
            return this.i.actualMaximumValue;
        },
        set: function (v) {
            this.i.actualMaximumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "minimumValue", {
        /**
         * Gets or sets the axis MinimumValue.
        */
        get: /**
             * Gets or sets the axis MinimumValue.
            */
        function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "maximumValue", {
        /**
         * Gets or sets the axis MaximumValue.
        */
        get: /**
             * Gets or sets the axis MaximumValue.
            */
        function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "isDateTime", {
        /**
         * Checks if the axis is of date time axis type
        */
        get: /**
             * Checks if the axis is of date time axis type
            */
        function () {
            return this.i.b5;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBaseComponent.prototype, "isSorting", {
        /**
         * Checks if axis requires sorting of items
        */
        get: /**
             * Checks if axis requires sorting of items
            */
        function () {
            return this.i.cc;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Gets the index of the data item with the value nearest the given value.
    
    * @param unscaledValue  * The value to find a value close to.
    */
    /**
         * Gets the index of the data item with the value nearest the given value.
        
        * @param unscaledValue  * The value to find a value close to.
        */
    IgxTimeAxisBaseComponent.prototype.getIndexClosestToUnscaledValue = /**
         * Gets the index of the data item with the value nearest the given value.
        
        * @param unscaledValue  * The value to find a value close to.
        */
    function (unscaledValue) {
        var iv = this.i.i$f(unscaledValue);
        return (iv);
    };
    /**
     * Updates the axis when the data has been changed.
    
    */
    /**
         * Updates the axis when the data has been changed.
        
        */
    IgxTimeAxisBaseComponent.prototype.notifyDataChanged = /**
         * Updates the axis when the data has been changed.
        
        */
    function () {
        this.i.i$i();
    };
    IgxTimeAxisBaseComponent.propDecorators = {
        "dateTimeMemberPath": [{ type: Input },],
        "isDataPreSorted": [{ type: Input },],
        "actualMinimumValue": [{ type: Input },],
        "actualMaximumValue": [{ type: Input },],
        "minimumValue": [{ type: Input },],
        "maximumValue": [{ type: Input },],
    };
    return IgxTimeAxisBaseComponent;
}(IgxCategoryAxisBaseComponent));
export { IgxTimeAxisBaseComponent };
//# sourceMappingURL=igx-time-axis-base-component.js.map