import { Component, Input } from "@angular/core";
import { TypeRegistrar } from "igniteui-angular-core/ES5/type";
import { TimeAxisBreak } from "./TimeAxisBreak";
export var IgxTimeAxisBreakComponent_PROVIDERS = [];
var IgxTimeAxisBreakComponent = /** @class */ (function () {
    function IgxTimeAxisBreakComponent() {
        this._renderer = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxTimeAxisBreakComponent.prototype.onImplementationCreated = function () {
    };
    IgxTimeAxisBreakComponent.prototype.createImplementation = function () {
        return new TimeAxisBreak();
    };
    IgxTimeAxisBreakComponent.prototype.ngOnInit = function () {
    };
    IgxTimeAxisBreakComponent.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
        this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
    };
    IgxTimeAxisBreakComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "start", {
        /**
     * The start time of the axis break.
    */
        get: /**
             * The start time of the axis break.
            */
        function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "end", {
        /**
         * The end time of the axis break.
        */
        get: /**
             * The end time of the axis break.
            */
        function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisBreakComponent.prototype, "interval", {
        /**
         * The interval at which to repeat this break, expressed as a TimeSpan.
        */
        get: /**
             * The interval at which to repeat this break, expressed as a TimeSpan.
            */
        function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxTimeAxisBreakComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxTimeAxisBreakComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-time-axis-break',
                    template: "",
                    providers: IgxTimeAxisBreakComponent_PROVIDERS
                },] },
    ];
    /** @nocollapse */
    IgxTimeAxisBreakComponent.ctorParameters = function () { return []; };
    IgxTimeAxisBreakComponent.propDecorators = {
        "start": [{ type: Input },],
        "end": [{ type: Input },],
        "interval": [{ type: Input },],
    };
    return IgxTimeAxisBreakComponent;
}());
export { IgxTimeAxisBreakComponent };
//# sourceMappingURL=igx-time-axis-break-component.js.map