import { Component, Input } from "@angular/core";
import { TypeRegistrar } from "igniteui-angular-core/ES5/type";
import { TimeAxisInterval } from "./TimeAxisInterval";
import { TimeAxisIntervalType, TimeAxisIntervalType_$type } from "./TimeAxisIntervalType";
import { ensureEnum } from "igniteui-angular-core/ES5/componentUtil";
export var IgxTimeAxisIntervalComponent_PROVIDERS = [];
var IgxTimeAxisIntervalComponent = /** @class */ (function () {
    function IgxTimeAxisIntervalComponent() {
        this._renderer = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxTimeAxisIntervalComponent.prototype.onImplementationCreated = function () {
    };
    IgxTimeAxisIntervalComponent.prototype.createImplementation = function () {
        return new TimeAxisInterval();
    };
    IgxTimeAxisIntervalComponent.prototype.ngOnInit = function () {
    };
    IgxTimeAxisIntervalComponent.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
        this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
    };
    IgxTimeAxisIntervalComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "range", {
        /**
     * The visible axis range at which to apply this interval.
    */
        get: /**
             * The visible axis range at which to apply this interval.
            */
        function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "interval", {
        /**
         * The interval, expressed as a multiple of IntervalType.
        */
        get: /**
             * The interval, expressed as a multiple of IntervalType.
            */
        function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTimeAxisIntervalComponent.prototype, "intervalType", {
        /**
         * The unit of time for this interval.
        */
        get: /**
             * The unit of time for this interval.
            */
        function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(TimeAxisIntervalType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgxTimeAxisIntervalComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxTimeAxisIntervalComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-time-axis-interval',
                    template: "",
                    providers: IgxTimeAxisIntervalComponent_PROVIDERS
                },] },
    ];
    /** @nocollapse */
    IgxTimeAxisIntervalComponent.ctorParameters = function () { return []; };
    IgxTimeAxisIntervalComponent.propDecorators = {
        "range": [{ type: Input },],
        "interval": [{ type: Input },],
        "intervalType": [{ type: Input },],
    };
    return IgxTimeAxisIntervalComponent;
}());
export { IgxTimeAxisIntervalComponent };
//# sourceMappingURL=igx-time-axis-interval-component.js.map