import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxBrushScaleComponent } from "./igx-brush-scale-component";
import { ValueBrushScale } from "./ValueBrushScale";
import { ensureBool } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Represents a brush scale that uses value-based brush selection.
*/
export var IgxValueBrushScaleComponent_PROVIDERS = [{ provide: IgxBrushScaleComponent, useExisting: forwardRef(function () { return IgxValueBrushScaleComponent; }) }];
var IgxValueBrushScaleComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxValueBrushScaleComponent, _super);
    function IgxValueBrushScaleComponent() {
        return _super.call(this) || this;
    }
    IgxValueBrushScaleComponent.prototype.createImplementation = function () {
        return new ValueBrushScale();
    };
    Object.defineProperty(IgxValueBrushScaleComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxValueBrushScaleComponent.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value for this scale.
        */
        get: /**
             * Gets or sets the minimum value for this scale.
            */
        function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxValueBrushScaleComponent.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value for this scale.
        */
        get: /**
             * Gets or sets the maximum value for this scale.
            */
        function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxValueBrushScaleComponent.prototype, "isLogarithmic", {
        /**
         * Gets or sets whether the scale is logarithmic.
        */
        get: /**
             * Gets or sets whether the scale is logarithmic.
            */
        function () {
            return this.i.isLogarithmic;
        },
        set: function (v) {
            this.i.isLogarithmic = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxValueBrushScaleComponent.prototype, "logarithmBase", {
        /**
         * Gets or sets the logarithm base for this scale.
        */
        get: /**
             * Gets or sets the logarithm base for this scale.
            */
        function () {
            return this.i.logarithmBase;
        },
        set: function (v) {
            this.i.logarithmBase = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxValueBrushScaleComponent.prototype, "isReady", {
        /**
         * Checks if the value brush scale is ready for usage in the chart
        */
        get: /**
             * Checks if the value brush scale is ready for usage in the chart
            */
        function () {
            return this.i.isReady;
        },
        enumerable: true,
        configurable: true
    });
    IgxValueBrushScaleComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-value-brush-scale',
                    template: "",
                    providers: [{ provide: IgxBrushScaleComponent, useExisting: forwardRef(function () { return IgxValueBrushScaleComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxValueBrushScaleComponent.ctorParameters = function () { return []; };
    IgxValueBrushScaleComponent.propDecorators = {
        "minimumValue": [{ type: Input },],
        "maximumValue": [{ type: Input },],
        "isLogarithmic": [{ type: Input },],
        "logarithmBase": [{ type: Input },],
    };
    return IgxValueBrushScaleComponent;
}(IgxBrushScaleComponent));
export { IgxValueBrushScaleComponent };
//# sourceMappingURL=igx-value-brush-scale-component.js.map