import { Output, EventEmitter, Component, ViewContainerRef, Injector, ComponentFactoryResolver, Renderer2, ViewChild, Inject, Input, NgZone, ChangeDetectionStrategy } from '@angular/core';
import { DOCUMENT } from '@angular/platform-browser';
import { ZoomSliderOrientation, ZoomSliderOrientation_$type } from './ZoomSliderOrientation';
import { ZoomSliderResolvingAxisValueEventArgs } from './igx-zoom-slider-resolving-axis-value-event-args';
import { RectChangedEventArgs } from "igniteui-angular-core/ES5/igx-rect-changed-event-args";
import { ZoomSlider } from "./ZoomSlider";
import { fromRect, toRect, ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss } from "igniteui-angular-core/ES5/componentUtil";
import { FontInfo } from "igniteui-angular-core/ES5/FontInfo";
import { AngularRenderer } from "igniteui-angular-core/ES5/angular-renderer";
import { delegateCombine } from "igniteui-angular-core/ES5/type";
export var IgxZoomSliderComponent_PROVIDERS = [];
var ZoomSliderStylingDefaults = {};
var IgxZoomSliderComponent = /** @class */ (function () {
    function IgxZoomSliderComponent(renderer, _elRef, document, ngZone, injector, componentFactoryResolver) {
        var _this = this;
        this.renderer = renderer;
        this._elRef = _elRef;
        this.document = document;
        this.ngZone = ngZone;
        this.injector = injector;
        this.componentFactoryResolver = componentFactoryResolver;
        this._wrapper = null;
        this._implementation = null;
        this._resolvingAxisValue = null;
        this._windowRectChanged = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this.container = renderer.createElement("div");
        renderer.appendChild(_elRef.element.nativeElement, this.container);
        renderer.setStyle(this.container, "display", "block");
        renderer.setStyle(this.container, "width", "100%");
        renderer.setStyle(this.container, "height", "100%");
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        var ren = new AngularRenderer(root, this.renderer, this.document, this.ngZone, true, ZoomSliderStylingDefaults);
        this._wrapper = ren;
        var zoomSlider = this.i;
        this._zoomSlider = zoomSlider;
        zoomSlider.provideContainer(ren);
        zoomSlider.notifySizeChanged();
        ren.addSizeWatcher(function () {
            _this._zoomSlider.notifySizeChanged();
        });
        this.updateStyle();
    }
    Object.defineProperty(IgxZoomSliderComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
            this._zoomSlider.notifySizeChanged();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
            this._zoomSlider.notifySizeChanged();
        },
        enumerable: true,
        configurable: true
    });
    // supports angular themes or custom properties set in CSS
    // supports angular themes or custom properties set in CSS
    IgxZoomSliderComponent.prototype.updateStyle = 
    // supports angular themes or custom properties set in CSS
    function () {
        initializePropertiesFromCss(this._elRef.element.nativeElement, this, "zoom-slider-");
    };
    IgxZoomSliderComponent.prototype.ngOnDestroy = function () {
        this._zoomSlider.destroy();
        this._wrapper.destroy();
    };
    IgxZoomSliderComponent.prototype.ngAfterContentInit = function () {
    };
    IgxZoomSliderComponent.prototype.createImplementation = function () {
        return new ZoomSlider();
    };
    Object.defineProperty(IgxZoomSliderComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "panTransitionDuration", {
        get: function () {
            return this.i.bl;
        },
        set: function (v) {
            this.i.bl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "maxZoomWidth", {
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
        function () {
            return this.i.bi;
        },
        set: function (v) {
            this.i.bi = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "actualPixelScalingRatio", {
        get: function () {
            return this.i.a4;
        },
        set: function (v) {
            this.i.a4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "windowRect", {
        get: function () {
            return fromRect(this.i.windowRect);
        },
        set: function (v) {
            this.i.windowRect = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "minZoomWidth", {
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "startInset", {
        get: function () {
            return this.i.startInset;
        },
        set: function (v) {
            this.i.startInset = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "endInset", {
        get: function () {
            return this.i.endInset;
        },
        set: function (v) {
            this.i.endInset = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "trackStartInset", {
        get: function () {
            return this.i.trackStartInset;
        },
        set: function (v) {
            this.i.trackStartInset = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "trackEndInset", {
        get: function () {
            return this.i.trackEndInset;
        },
        set: function (v) {
            this.i.trackEndInset = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "barExtent", {
        get: function () {
            return this.i.barExtent;
        },
        set: function (v) {
            this.i.barExtent = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "orientation", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureEnum(ZoomSliderOrientation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbBrush", {
        get: function () {
            return brushToString(this.i.e8);
        },
        set: function (v) {
            this.i.e8 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbStrokeThickness", {
        get: function () {
            return this.i.be;
        },
        set: function (v) {
            this.i.be = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbStrokeThickness", {
        get: function () {
            return this.i.a9;
        },
        set: function (v) {
            this.i.a9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbBrush", {
        get: function () {
            return brushToString(this.i.e0);
        },
        set: function (v) {
            this.i.e0 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbOutline", {
        get: function () {
            return brushToString(this.i.e9);
        },
        set: function (v) {
            this.i.e9 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbOutline", {
        get: function () {
            return brushToString(this.i.e1);
        },
        set: function (v) {
            this.i.e1 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbRidgesBrush", {
        get: function () {
            return brushToString(this.i.fa);
        },
        set: function (v) {
            this.i.fa = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbRidgesBrush", {
        get: function () {
            return brushToString(this.i.e2);
        },
        set: function (v) {
            this.i.e2 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbWidth", {
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbWidth", {
        get: function () {
            return this.i.ba;
        },
        set: function (v) {
            this.i.ba = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerThumbHeight", {
        get: function () {
            return this.i.bd;
        },
        set: function (v) {
            this.i.bd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherThumbHeight", {
        get: function () {
            return this.i.a8;
        },
        set: function (v) {
            this.i.a8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerShadeBrush", {
        get: function () {
            return brushToString(this.i.e6);
        },
        set: function (v) {
            this.i.e6 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerShadeOutline", {
        get: function () {
            return brushToString(this.i.e7);
        },
        set: function (v) {
            this.i.e7 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerShadeStrokeThickness", {
        get: function () {
            return this.i.bc;
        },
        set: function (v) {
            this.i.bc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherShadeBrush", {
        get: function () {
            return brushToString(this.i.ey);
        },
        set: function (v) {
            this.i.ey = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherShadeOutline", {
        get: function () {
            return brushToString(this.i.ez);
        },
        set: function (v) {
            this.i.ez = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherShadeStrokeThickness", {
        get: function () {
            return this.i.a7;
        },
        set: function (v) {
            this.i.a7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "barBrush", {
        get: function () {
            return brushToString(this.i.et);
        },
        set: function (v) {
            this.i.et = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "barOutline", {
        get: function () {
            return brushToString(this.i.eu);
        },
        set: function (v) {
            this.i.eu = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "barStrokeThickness", {
        get: function () {
            return this.i.a5;
        },
        set: function (v) {
            this.i.a5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "rangeThumbBrush", {
        get: function () {
            return brushToString(this.i.fb);
        },
        set: function (v) {
            this.i.fb = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "rangeThumbOutline", {
        get: function () {
            return brushToString(this.i.fc);
        },
        set: function (v) {
            this.i.fc = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "rangeThumbStrokeThickness", {
        get: function () {
            return this.i.bj;
        },
        set: function (v) {
            this.i.bj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "rangeThumbRidgesBrush", {
        get: function () {
            return brushToString(this.i.fd);
        },
        set: function (v) {
            this.i.fd = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerCalloutBrush", {
        get: function () {
            return brushToString(this.i.e3);
        },
        set: function (v) {
            this.i.e3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerCalloutTextColor", {
        get: function () {
            return brushToString(this.i.e5);
        },
        set: function (v) {
            this.i.e5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerCalloutOutline", {
        get: function () {
            return brushToString(this.i.e4);
        },
        set: function (v) {
            this.i.e4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "lowerCalloutStrokeThickness", {
        get: function () {
            return this.i.bb;
        },
        set: function (v) {
            this.i.bb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherCalloutBrush", {
        get: function () {
            return brushToString(this.i.ev);
        },
        set: function (v) {
            this.i.ev = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherCalloutTextColor", {
        get: function () {
            return brushToString(this.i.ex);
        },
        set: function (v) {
            this.i.ex = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherCalloutOutline", {
        get: function () {
            return brushToString(this.i.ew);
        },
        set: function (v) {
            this.i.ew = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "higherCalloutStrokeThickness", {
        get: function () {
            return this.i.a6;
        },
        set: function (v) {
            this.i.a6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "isCustomThumbProvided", {
        get: function () {
            return this.i.ab;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "isCustomRangeThumbProvided", {
        get: function () {
            return this.i.z;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "isCustomBarProvided", {
        get: function () {
            return this.i.y;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "isCustomShadeProvided", {
        get: function () {
            return this.i.aa;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "areThumbCalloutsEnabled", {
        get: function () {
            return this.i.q;
        },
        set: function (v) {
            this.i.q = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "thumbCalloutTextStyle", {
        get: function () {
            if (this.i.o == null) {
                return null;
            }
            return this.i.o.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.o = fi;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Release any resources held by the ZoomSlider.

*/
    /**
         * Release any resources held by the ZoomSlider.
        
        */
    IgxZoomSliderComponent.prototype.destroy = /**
         * Release any resources held by the ZoomSlider.
        
        */
    function () {
        this.i.destroy();
    };
    /**
     * Called by the UI framework to provide a UI container for rendering this control.
    
    * @param container  * The UI container element.
    */
    /**
         * Called by the UI framework to provide a UI container for rendering this control.
        
        * @param container  * The UI container element.
        */
    IgxZoomSliderComponent.prototype.provideContainer = /**
         * Called by the UI framework to provide a UI container for rendering this control.
        
        * @param container  * The UI container element.
        */
    function (container) {
        this.i.provideContainer(container);
    };
    IgxZoomSliderComponent.prototype.flush = function () {
        this.i.c3();
    };
    IgxZoomSliderComponent.prototype.trackDirty = function () {
        this.i.trackDirty();
    };
    /**
     * Shows the ZoomSlider.
    
    */
    /**
         * Shows the ZoomSlider.
        
        */
    IgxZoomSliderComponent.prototype.show = /**
         * Shows the ZoomSlider.
        
        */
    function () {
        this.i.show();
    };
    /**
     * Hides the ZoomSlider.
    
    */
    /**
         * Hides the ZoomSlider.
        
        */
    IgxZoomSliderComponent.prototype.hide = /**
         * Hides the ZoomSlider.
        
        */
    function () {
        this.i.hide();
    };
    Object.defineProperty(IgxZoomSliderComponent.prototype, "resolvingAxisValue", {
        get: function () {
            var _this = this;
            if (this._resolvingAxisValue == null) {
                this._resolvingAxisValue = new EventEmitter();
                this.i.resolvingAxisValue = delegateCombine(this.i.resolvingAxisValue, function (o, e) {
                    var outerArgs = new ZoomSliderResolvingAxisValueEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeResolvingAxisValue) {
                        _this.beforeResolvingAxisValue(_this, outerArgs);
                    }
                    _this._resolvingAxisValue.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._resolvingAxisValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxZoomSliderComponent.prototype, "windowRectChanged", {
        get: /**
             * Occurs just after the current ZoomSlider's window rectangle is changed.
            */
        function () {
            var _this = this;
            if (this._windowRectChanged == null) {
                this._windowRectChanged = new EventEmitter();
                this.i.windowRectChanged = delegateCombine(this.i.windowRectChanged, function (o, e) {
                    var outerArgs = new RectChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (_this.beforeWindowRectChanged) {
                        _this.beforeWindowRectChanged(_this, outerArgs);
                    }
                    _this._windowRectChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._windowRectChanged;
        },
        enumerable: true,
        configurable: true
    });
    IgxZoomSliderComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxZoomSliderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-zoom-slider',
                    template: "",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: IgxZoomSliderComponent_PROVIDERS,
                    styles: ["\n\t\t:host {\n\t\t\tdisplay: block;\n\t\t}\n\t"]
                },] },
    ];
    /** @nocollapse */
    IgxZoomSliderComponent.ctorParameters = function () { return [
        { type: Renderer2, },
        { type: ViewContainerRef, },
        { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] },] },
        { type: NgZone, },
        { type: Injector, },
        { type: ComponentFactoryResolver, },
    ]; };
    IgxZoomSliderComponent.propDecorators = {
        "height": [{ type: Input },],
        "width": [{ type: Input },],
        "_dynamicContent": [{ type: ViewChild, args: ["dynamicContent", { read: ViewContainerRef },] },],
        "panTransitionDuration": [{ type: Input },],
        "maxZoomWidth": [{ type: Input },],
        "pixelScalingRatio": [{ type: Input },],
        "actualPixelScalingRatio": [{ type: Input },],
        "windowRect": [{ type: Input },],
        "minZoomWidth": [{ type: Input },],
        "startInset": [{ type: Input },],
        "endInset": [{ type: Input },],
        "trackStartInset": [{ type: Input },],
        "trackEndInset": [{ type: Input },],
        "barExtent": [{ type: Input },],
        "orientation": [{ type: Input },],
        "lowerThumbBrush": [{ type: Input },],
        "lowerThumbStrokeThickness": [{ type: Input },],
        "higherThumbStrokeThickness": [{ type: Input },],
        "higherThumbBrush": [{ type: Input },],
        "lowerThumbOutline": [{ type: Input },],
        "higherThumbOutline": [{ type: Input },],
        "lowerThumbRidgesBrush": [{ type: Input },],
        "higherThumbRidgesBrush": [{ type: Input },],
        "lowerThumbWidth": [{ type: Input },],
        "higherThumbWidth": [{ type: Input },],
        "lowerThumbHeight": [{ type: Input },],
        "higherThumbHeight": [{ type: Input },],
        "lowerShadeBrush": [{ type: Input },],
        "lowerShadeOutline": [{ type: Input },],
        "lowerShadeStrokeThickness": [{ type: Input },],
        "higherShadeBrush": [{ type: Input },],
        "higherShadeOutline": [{ type: Input },],
        "higherShadeStrokeThickness": [{ type: Input },],
        "barBrush": [{ type: Input },],
        "barOutline": [{ type: Input },],
        "barStrokeThickness": [{ type: Input },],
        "rangeThumbBrush": [{ type: Input },],
        "rangeThumbOutline": [{ type: Input },],
        "rangeThumbStrokeThickness": [{ type: Input },],
        "rangeThumbRidgesBrush": [{ type: Input },],
        "lowerCalloutBrush": [{ type: Input },],
        "lowerCalloutTextColor": [{ type: Input },],
        "lowerCalloutOutline": [{ type: Input },],
        "lowerCalloutStrokeThickness": [{ type: Input },],
        "higherCalloutBrush": [{ type: Input },],
        "higherCalloutTextColor": [{ type: Input },],
        "higherCalloutOutline": [{ type: Input },],
        "higherCalloutStrokeThickness": [{ type: Input },],
        "areThumbCalloutsEnabled": [{ type: Input },],
        "thumbCalloutTextStyle": [{ type: Input },],
        "resolvingAxisValue": [{ type: Output },],
        "windowRectChanged": [{ type: Output },],
    };
    return IgxZoomSliderComponent;
}());
export { IgxZoomSliderComponent };
//# sourceMappingURL=igx-zoom-slider-component.js.map